<?php

class formHistoryOptions extends cmsForm {


      public function init($options = false)
		{
			$content_model = cmsCore::getModel('content');
			$ctypes        = $content_model->getContentTypes();

			$opt = [];

			if ($ctypes) {
				foreach ($ctypes as $ctype) {

					$cats_list     = [];
					$datasets_list = ['0' => ''];
					$fields_list   = ['' => ''];

					$cats = $content_model->getCategoriesTree($ctype['name']);

					if ($cats) {
						foreach ($cats as $cat) {
							if ($cat['ns_level'] > 1) {
								$cat['title'] = str_repeat('-', $cat['ns_level']) . ' ' . $cat['title'];
							}
							$cats_list[$cat['id']] = $cat['title'];

						}
					}

					$datasets = $content_model->getContentDatasets($ctype['id']);
					if ($datasets) {
						$datasets_list = ['0' => ''] + array_collection_to_list($datasets, 'id', 'title');
					}

					$fields = $content_model->getContentFields($ctype['name']);
					if ($fields) {
						$fields_list = ['' => ''] + array_collection_to_list($fields, 'name', 'title');
					}

					$opt['ctype_' . $ctype['name']] = [
						'type'   => 'fieldset',
						'title'  => $ctype['title'],
						'childs' => [			

							new fieldList($ctype['name'] . '_image', [
								'title'   => LANG_HISTORY_LIST_IMAGE,
								'default' => 'photo',
								'items'   => $fields_list,
							]),
							new fieldList($ctype['name'] . '_teaser', [
								'title'   => LANG_HISTORY_LIST_TEASER,
								'default' => 'teaser',
								'items'   => $fields_list,
							]),
							
						],
					];
				}
			}

			return $opt;
		}
		
		
}
