<?php

class onHistoryContentBeforeItem extends cmsAction {

    public function run($data){
		
		list($ctype, $item, $fields) = $data;
		
		
		$core = cmsCore::getInstance();
		$options = $this->options;
		
		$image_field = !empty($options[$ctype['name'].'_image']) ? $options[$ctype['name'].'_image'] : '';
		$teaser_field = !empty($options[$ctype['name'].'_teaser']) ? $options[$ctype['name'].'_teaser'] : '';
		
		
		$target = array(
		'target_controller'=>$core->controller, 
		'target_subject'=>$ctype['name'], 
		'target_id'=>$item['id'], 
		'target_title'=>$item['title'], 
		'target_url'=>$item['slug'], 
		'target_image'=>(!empty($item[$image_field]) ? $item[$image_field] : ''), 
		'target_teaser'=>(!empty($item[$teaser_field]) ? html_clean($item[$teaser_field]) : '')
		);
		
		$ip = sprintf('%u', ip2long(cmsUser::getIp()));
		
        $isTracked = $this->model->isTracked($target, $this->cms_user->id, $ip);
		if(!$isTracked){
	    $this->model->addTracking($target, $this->cms_user->id, $ip);
		}
		
		$this->model->deleteOldTracks($target, $this->cms_user->id, $ip);

        return array($ctype, $item, $fields);

    }

}
