<?php

class modelHistory extends cmsModel {
	
	
    public function filterTargetObject($target_controller, $target_subject) {
        return $this->filterEqual('target_controller', $target_controller)->
            filterEqual('target_subject', $target_subject);

    }   
	public function filterTarget($target_controller, $target_subject, $target_id = null) {

        return $this->filterEqual('target_controller', $target_controller)->
            filterEqual('target_subject', $target_subject)->
            filterEqual('target_id', $target_id);

    }
	
	
//============================================================================//
//============================================================================//


    public function isTracked($target=null, $user_id=false, $ip=false){
		
		
	    if (!$target){ return false; }

        if(!$user_id){
            $this->filterEqual('ip', $ip);
        } else {
            $this->filterEqual('user_id', $user_id);
        }

        $this->filterTarget($target['target_controller'], $target['target_subject'], $target['target_id']);

        $this->useCache('history.list');

        $count = $this->orderBy('id','DESC')->getCount('history_log');

        $this->resetFilters();

        return $count > 0 ? true : false;

    }
	
//============================================================================//
//============================================================================//

    public function getHistoryList($target=null, $user_id=false, $ip=false, $limit=null){
		
		
        $this->useCache('history.list');

		if($user_id){
        $this->filterEqual('user_id', $user_id);
		}else{
		$this->filterEqual('ip', $ip);	
		}
		
		if(!empty($target['target_controller']) && !empty($target['target_subject'])){
			$this->filterTarget($target['target_controller'], $target['target_subject']); 
		}
		
		if($limit){
			$this->limit($limit);
		}

        $items = $this->orderBy('id','DESC')->get('history_log');
		
		$this->resetFilters();
        return $items;

    }
	
	
    public function getHistoryTargetsIds($target=null, $user_id=false, $ip=false, $limit=null){
		
		
        $this->useCache('history.list');

		if($user_id){
        $this->filterEqual('user_id', $user_id);
		}else{
		$this->filterEqual('ip', $ip);	
		}
		
		if(!empty($target['target_controller']) && !empty($target['target_subject'])){
			$this->filterTargetObject($target['target_controller'], $target['target_subject']); 
		}
		
		if($limit){
			$this->limit($limit);
		}

		$items = $this->selectOnly('target_id')->orderBy('id','DESC')->get('history_log', function($item, $model){		
			return $item['target_id'];
		});

		$this->resetFilters();
        return $items;

    }   


	public function getHistoryIds($target=null, $user_id=false, $ip=false, $limit=null){
		
		
        $this->useCache('history.list');

		if($user_id){
        $this->filterEqual('user_id', $user_id);
		}else{
		$this->filterEqual('ip', $ip);	
		}
		
		if(!empty($target['target_controller']) && !empty($target['target_subject'])){
			$this->filterTargetObject($target['target_controller'], $target['target_subject']); 
		}
		
		if($limit){
			$this->limit($limit);
		}
		

		$items = $this->selectOnly('id')->orderBy('id','DESC')->get('history_log', function($item, $model){		
			return $item['id'];
		});
		
		$this->resetFilters();
        return $items;

    }
	

    public function addTracking($target=null, $user_id=null, $ip=null){

	    if (empty($target['target_subject']) || empty($target['target_id'])){ return false; }
		
        // Получаем модель целевого контроллера
        $target_model = cmsCore::getModel( $target['target_controller'] );

        // Получаем URL и заголовок комментируемой страницы
        $target_info = $target_model->getTargetItemInfo($target['target_subject'], $target['target_id']);

        if (!$target_info){ return false; }
		
        if (!$user_id && !$ip){ return false; }
		
        cmsCache::getInstance()->clean('history.list');

        return $this->insert('history_log', array(
            'user_id'           => $user_id,
            'ip'                => $ip,
            'target_controller' => $target['target_controller'],
            'target_subject'    => $target['target_subject'],
            'target_id'         => $target['target_id'],
            'target_title'      => $target['target_title'],
            'target_url'        => $target['target_url'],
            'target_image'      => $target['target_image'],
            'target_teaser'     => $target['target_teaser']
        ));

    }
	
    public function deleteTracking($id){

        cmsCache::getInstance()->clean('history.list');

        return $this->delete('history_log', $id);

    }
	
    public function deleteOldTracks($target=null, $user_id=null, $ip=null){
		
		if(empty($target['target_controller']) || empty($target['target_subject'])){
			return false;
		}
		
		$ids = $this->getHistoryIds($target, $user_id, $ip, 30);	
       
		
		if($ids){		
		
		cmsCache::getInstance()->clean('history.list');		
		return $this->filterNotIn('id',$ids)->filterEqual('target_controller', $target['target_controller'])->
            filterEqual('target_subject', $target['target_subject'])->
            filterEqual('target_id', $target['target_id'])->deleteFiltered('history_log');
		
		}
		



    }



}
