<?php
class widgetHistoryList extends cmsWidget {

    public $is_cacheable = false;
    public function run(){

	 $ctype_id        = $this->getOption('ctype_id');
	 $limit           = $this->getOption('limit');
	 $style           = $this->getOption('style');
	 $show_logdate    = false;
	 $is_show_details    = $this->getOption('show_details');
	 $teaser_len      = $this->getOption('teaser_len');
	 $show_teaser        = $this->getOption('show_teaser');
	 
	 $show_all        = $this->getOption('show_all');
	 
	 
		$image_field = null;
		$teaser_field = null;
	 
		
		$ctype = null;
		
        $user = cmsUser::getInstance();
        $core = cmsCore::getInstance();
        $model = cmsCore::getModel('content');
        $options = cmsController::loadOptions('history');
		
	if($ctype_id){
        $ctype = $model->getContentType($ctype_id);
	}else{
		$ctype = cmsModel::getCachedResult('current_ctype');
	}
		
		if(!$ctype && !$show_all){
			return false;
		}
		
		
		
		if($ctype){
		$image_field = !empty($options[$ctype['name'].'_image']) ? $options[$ctype['name'].'_image'] : '';
		$teaser_field = !empty($options[$ctype['name'].'_teaser']) ? $options[$ctype['name'].'_teaser'] : '';
		$target_controller = 'content';
		}
		
		if(!$show_teaser){
			$teaser_field = '';
		}
		
		
   	    $current_ctype_item = cmsModel::getCachedResult('current_ctype_item');        
		$current_ctype_category = cmsModel::getCachedResult('current_ctype_category');
		
		
		
        $historyModel = cmsCore::getModel('history');
		
		$target = array(
		'target_controller'=>(!empty($ctype['name']) ? $target_controller : null), 
		'target_subject'=>(!empty($ctype['name']) ? $ctype['name'] : null)
		);		
		$ip = sprintf('%u', ip2long(cmsUser::getIp()));
		
		
		
		
		
		
		
		
		
		
		
		// Выводить все записи если тип контента не определён		
		// Облегчённый вывод, выводится напрямую из лога. Заголовок, изображение, описание записи могу оказатся не актуальными.
		////////////////////////////////////////
		
		if($show_all && !$ctype){
		
		if(!empty($current_ctype_item['id'])){
			$historyModel->filterNotEqual('i.target_id',$current_ctype_item['id']);
		}	
		
		$items_log = $historyModel->getHistoryList($target, $user->id, $ip);
		if (!$items_log) { return false; }
		
		$items = array();
		foreach($items_log as $item){
			
			$image_field = !empty($options[$item['target_subject'].'_image']) ? $options[$item['target_subject'].'_image'] : '';
		    $teaser_field = !empty($options[$item['target_subject'].'_teaser']) ? $options[$item['target_subject'].'_teaser'] : '';
			
			$target_item['date_log'] = $item['date_log'];
			$target_item['title'] = $item['target_title'];
			$target_item['ctype_name'] = $item['target_subject'];
			$target_item['id'] = $item['target_id'];
			$target_item['slug'] = $item['target_url'];
			$target_item[$image_field] = $item['target_image'];		
			$target_item[$teaser_field] = (!$show_teaser ? '' : $item['target_teaser']);
			$target_item['is_private'] = false;	
			$target_item['user']['is_friend'] = null;
			$target_item['date_pub'] = null;
			$target_item['parent_url'] = null;
			$target_item['parent_id'] = null;
			$target_item['user']['id'] = $item['user_id'];
			$target_item['comments'] = null;
			
			
			$items[] = $target_item;
		}
			
		if($style){
            $this->setTemplate('list_'.$style);
        } else {
            $this->setTemplate($this->tpl_body);
        }
		
        return array(
		'show_all'   => $show_all,
		'options'   => $options,
		'show_logdate'   => $show_logdate,
		'is_show_details'   => false,
		'teaser_len'     => $teaser_len,
		'teaser_field'  => $teaser_field,
		'image_field'   => $image_field,
		'hide_except_title'  => false,
		'items'          => $items,
		'ctype'          => $ctype,
		'target_item'    => $current_ctype_item,
		'category'       => $current_ctype_category
		);	
			
		}
		
		////////////////////////////////////
		
		
		
		
		
	
		
		
		$targets_ids = null;
		
		
		
		if(!empty($current_ctype_item['id'])){
			$historyModel->filterNotEqual('i.target_id',$current_ctype_item['id']);
		}	
		
		
		if($show_logdate){
		// Показывать дату просмотра	
			
			
	
		$history_log = $historyModel->selectOnly('target_id')->selectOnly('date_log')->getHistoryList($target, $user->id, $ip);
		
		$targets = array();
		if(!$history_log){
			return false;
		}
		
		foreach($history_log as $log){
			$targets_ids[] = $log['target_id'];
			$targets[$log['target_id']] = $log['date_log'];
		}
		
		
		
		
		////////////////////////////
		}else{
			
			
			
		$targets_ids = $historyModel->getHistoryTargetsIds($target, $user->id, $ip);	
			
			
			
		}
		
		
	
		
		
	
	
	
		if(!$targets_ids){
			return false;
		}
		
		
		
		// применяем приватность
        // флаг показа только названий
        $hide_except_title = $model->applyPrivacyFilter($ctype, cmsUser::isAllowed($ctype['name'], 'view_all'));

        // Скрываем записи из скрытых родителей (приватных групп и т.п.)
        $model->enableHiddenParentsFilter();
		
		
		
		list($ctype, $model) = cmsEventsManager::hook("content_list_filter", array($ctype, $model));
		list($ctype, $model) = cmsEventsManager::hook("content_{$ctype['name']}_list_filter", array($ctype, $model));

        $itemss = $model->
                    filterIn('i.id',$targets_ids)->
                    limit($limit)->
                    getContentItems($ctype['name']);
		
        if (!$itemss) { return false; }		
		
		$items = array();
		foreach($itemss	as $item){
			
			// Показывать дату просмотра
			if($show_logdate){
			$item['date_log'] = $targets[$item['id']]['date_log'];
			}
			//
			
			$items[] = $item;
		}	




		

        list($ctype, $items) = cmsEventsManager::hook("content_before_list", array($ctype, $items));
        list($ctype, $items) = cmsEventsManager::hook("content_{$ctype['name']}_before_list", array($ctype, $items));

        if($style){
            $this->setTemplate('list_'.$style);
        } else {
            $this->setTemplate($this->tpl_body);
        }
		
        return array(
		'show_all'   => $show_all,
		'options'   => $options,
		'show_logdate'   => $show_logdate,
		'is_show_details'   => $is_show_details,
		'teaser_len'     => $teaser_len,
		'teaser_field'  => $teaser_field,
		'image_field'   => $image_field,
		'hide_except_title'  => $hide_except_title,
		'items'          => $items,
		'ctype'          => $ctype,
		'target_item'    => $current_ctype_item,
		'category'       => $current_ctype_category
		);

    }

}
